(* $Id: Misc.v,v 1.3 2011-10-22 11:13:33 deraugla Exp $ *)

Require Import Utf8.
Require Import Arith.

Lemma minus_le : ∀ a b, a - b = 0 → a ≤ b.
Proof.
  induction a; intros b H1.
  apply le_0_n.
  destruct b.
  inversion H1.
  simpl in H1.
  apply le_n_S, IHa, H1.
Qed.

Lemma lt_minus_weak : ∀ a b c, a < b → a - c < b.
Proof.
  intros a b c; revert a b; induction c; intros a b H1.
   rewrite <- minus_n_O; apply H1.
   apply IHc in H1.
   assert (a - S c ≤ a - c) as H2.
    apply minus_le_compat_l.
    apply le_S, le_n.
    apply le_trans with (m := S (a - c)); [apply le_n_S, H2 | apply H1].
Qed.
